#include "Struct.h"
std::ostream& operator<<(std::ostream& out, const Node& element) {
	out << element.ID_node << " | ";
	for (auto& e : element.coord)
		out << e<<" ";
	out << " | " << element.flag << " | " << std::endl;
	return out;
}

std::ostream& operator<<(std::ostream& out, const FiniteElement& element) {
	out << element.ID << " | " << element.ID_material << " | ";
	for (auto& e : element.id_vertices)
		out << e << " ";
	out << " | " << std::endl;
	return out;
}

std::ostream& operator<<(std::ostream& out, const BoundaryFiniteElement& element) {
	out << element.ID_boundary << " | " << element.ID_surface << " | ";
	for (auto& e : element.node_boundary)
		out << e << " ";
	out << " | " << std::endl;
	return out;
}

Edge::Edge(size_t h_id, size_t l_id) :
	head_id(h_id),
	last_id(l_id)
{}

bool Edge::operator == (const Edge& sec_odj) const
{
	return (head_id == sec_odj.head_id && last_id == sec_odj.last_id) ||
		(last_id == sec_odj.head_id && head_id == sec_odj.last_id);
}

std::size_t EdgeHash::operator() (const Edge& _p) const{
	std::size_t o_seed = 0;
	if (_p.head_id > _p.last_id)
	{
		o_seed ^= std::hash<int>() (_p.head_id) + 0x9e3779b9 + (o_seed << 6) + (o_seed >> 2);
		o_seed ^= std::hash<int>() (_p.last_id) + 0x9e3779b9 + (o_seed << 6) + (o_seed >> 2);
	}
	else
	{
		o_seed ^= std::hash<int>() (_p.last_id) + 0x9e3779b9 + (o_seed << 6) + (o_seed >> 2);
		o_seed ^= std::hash<int>() (_p.head_id) + 0x9e3779b9 + (o_seed << 6) + (o_seed >> 2);
	}

	return o_seed;
}

