#pragma once
#include <iostream>
#include <vector>

struct Node {
	size_t ID_node;
	std::vector<float> coord;
	bool flag;
	Node(size_t _ID_node, std::vector<float> _coord, bool _flag) : ID_node(_ID_node),
						                     coord(std::move(_coord)),flag(_flag) {};

	friend std::ostream& operator<<(std::ostream& out, const Node& el);
};

struct FiniteElement {
	size_t ID;
	size_t ID_material;
	std::vector<size_t> id_vertices;
	FiniteElement(size_t _ID, size_t _ID_material, std::vector<size_t>_materials) : ID(_ID),
										ID_material(_ID_material), id_vertices(std::move(_materials)) {};

	friend std::ostream& operator<<(std::ostream& out, const FiniteElement& el);

};

struct BoundaryFiniteElement {
	size_t ID_boundary;
	size_t ID_surface;
	std::vector<size_t> node_boundary;
	BoundaryFiniteElement(size_t _ID_boundary,size_t _ID_surface, std::vector<size_t>_node_boundary) : ID_boundary(_ID_boundary),
		                                              ID_surface(_ID_surface), node_boundary(std::move(_node_boundary)) {};

	friend std::ostream& operator<<(std::ostream& out, const BoundaryFiniteElement& el);
};

struct Edge{
	size_t head_id;
	size_t last_id;
	size_t self_id;
	Edge() = default;
	Edge(size_t, size_t);
	bool operator == (const Edge&) const;
};

class EdgeHash{
public:
	std::size_t operator() (const Edge& _p) const;
};
